FarmStorageAccess ={
  _VERSION = 'FarmStorageAccess.lua 1.0.0',
  _URL     = 'http://www.modhoster.de',
  _DESCRIPTION = 'Placeable farm tip trigger',
  _LICENSE = [[
    MIT LICENSE

    Copyright (c) 2016 Eisbearg

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the
    "Software"), to deal in the Software without restriction, including
    without limitation the rights to use, copy, modify, merge, publish,
    distribute, sublicense, and/or sell copies of the Software, and to
    permit persons to whom the Software is furnished to do so, subject to
    the following conditions:

    The above copyright notice and this permission notice shall be included
    in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ]]
}



source(Utils.getFilename("inspect.lua", g_currentModDirectory.."/scripts/"))




FarmStorageAccess_mt = Class(FarmStorageAccess, Placeable);
InitObjectClass(FarmStorageAccess, "FarmStorageAccess");


function FarmStorageAccess:new(isServer, isClient, customMt)
	local mt = customMt or FarmStorageAccess_mt;
    local self = Placeable:new(isServer, isClient, mt);
    registerObjectClassName(self, "FarmStorageAccess");
    return self;
end;


function FarmStorageAccess:delete()
    removeTrigger(self.FarmStorageAccessTriggerId);
    unregisterObjectClassName(self);
    FarmStorageAccess:superClass().delete(self);
end;


function FarmStorageAccess:deleteFinal()
    FarmStorageAccess:superClass().deleteFinal(self);
end;


function FarmStorageAccess:load(xmlFilename, x,y,z, rx,ry,rz, initRandom)
    if not FarmStorageAccess:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, initRandom) then
        return false;
    end;

	return true;
end;


function FarmStorageAccess:finalizePlacement()
	FarmStorageAccess:superClass().finalizePlacement(self);
	
	local org_isLoadingMap = g_currentMission.isLoadingMap;
	g_currentMission.isLoadingMap = true

    self.FarmStorageAccessTriggerId = Utils.indexToObject(self.nodeId, "0>0|1");
    MultiSiloTrigger:onCreate(self.FarmStorageAccessTriggerId);

	g_currentMission.isLoadingMap = org_isLoadingMap;
end;


registerPlaceableType("FarmStorageAccess", FarmStorageAccess);
